
/*
	DiskBench 0.1
	2000 Jens Kristian Jensen (jensk@migselv.com)

	WARNING: Take care.
	Use is entirely on your own risk.
	Watch where you point that thing!!
*/

#include <File.h>
#include <StopWatch.h>
#include <string>

main() {
	const int one_meg=1024*1024;
	const int iterations=100;
	char buffer[one_meg];
	string filename("/dev/disk/ide/ata/2/master/0/raw");

	if(filename=="/dev/disk/ide/ata/0/master/0/raw") {
		cout << "You don't really mean that!\n";
		exit(0);
	}

	BFile *file=new BFile(filename.c_str(),B_READ_WRITE);
	cout << "Testing read...\n";
	BStopWatch *stopwatch=new BStopWatch("Disk Read Timer",true);
	for(int i=0;i<iterations;i++)	
		file->Read(buffer,one_meg);
	float et=stopwatch->ElapsedTime();
	cout << "Read " << iterations << " MB in " << (int)et/1000 << " msecs. (" << (iterations*1000000)/et << " MB/s)\n";
	delete stopwatch;

	// Warning, please comment out the below block of code
	// if you want to do a read only test
	// (and thus don't destroy the contents of yuor harddrive)
	
	cout << "Testing write...\n";
	stopwatch=new BStopWatch("Disk Write Timer",true);
	for(int i=0;i<iterations;i++)
		file->Write(buffer,one_meg);
	et=stopwatch->ElapsedTime();
	cout << "Wrote " << iterations << " MB in " << (int)et/1000 << " msecs. (" << (iterations*1000000)/et << " MB/s)\n";
	delete stopwatch;


	delete file;
}
